import * as graphql from './graphql';
import { SchemaComposer } from './SchemaComposer';
export { graphql };
const schemaComposer = new SchemaComposer();
const sc = schemaComposer;
export { SchemaComposer, // SchemaComposer class
schemaComposer, // SchemaComposer default global instance
sc };
export { ObjectTypeComposer, isComposeOutputType } from './ObjectTypeComposer';
export { InputTypeComposer, isComposeInputType } from './InputTypeComposer';
export { EnumTypeComposer } from './EnumTypeComposer';
export { ScalarTypeComposer } from './ScalarTypeComposer';
export { InterfaceTypeComposer } from './InterfaceTypeComposer';
export { UnionTypeComposer } from './UnionTypeComposer';
export { Resolver } from './Resolver';
export { TypeStorage } from './TypeStorage';
export { TypeMapper } from './TypeMapper'; // Scalar types

export { GraphQLDate, GraphQLBuffer, GraphQLGeneric, GraphQLJSON } from './type'; // Utils

export { getProjectionFromAST, getFlatProjectionFromAST } from './utils/projection';
export { toInputObjectType, convertInputObjectField } from './utils/toInputObjectType';
export * from './utils/misc';
export * from './utils/is';
export * from './utils/graphqlVersion';
export { default as toDottedObject } from './utils/toDottedObject';
export { default as deepmerge } from './utils/deepmerge';
export { filterByDotPaths } from './utils/filterByDotPaths';
export { pluralize } from './utils/pluralize';