"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  schemaComposer: true,
  sc: true,
  graphql: true,
  SchemaComposer: true,
  ObjectTypeComposer: true,
  isComposeOutputType: true,
  InputTypeComposer: true,
  isComposeInputType: true,
  EnumTypeComposer: true,
  ScalarTypeComposer: true,
  InterfaceTypeComposer: true,
  UnionTypeComposer: true,
  Resolver: true,
  TypeStorage: true,
  TypeMapper: true,
  GraphQLDate: true,
  GraphQLBuffer: true,
  GraphQLGeneric: true,
  GraphQLJSON: true,
  getProjectionFromAST: true,
  getFlatProjectionFromAST: true,
  toInputObjectType: true,
  convertInputObjectField: true,
  toDottedObject: true,
  deepmerge: true,
  filterByDotPaths: true,
  pluralize: true
};
Object.defineProperty(exports, "SchemaComposer", {
  enumerable: true,
  get: function get() {
    return _SchemaComposer.SchemaComposer;
  }
});
Object.defineProperty(exports, "ObjectTypeComposer", {
  enumerable: true,
  get: function get() {
    return _ObjectTypeComposer.ObjectTypeComposer;
  }
});
Object.defineProperty(exports, "isComposeOutputType", {
  enumerable: true,
  get: function get() {
    return _ObjectTypeComposer.isComposeOutputType;
  }
});
Object.defineProperty(exports, "InputTypeComposer", {
  enumerable: true,
  get: function get() {
    return _InputTypeComposer.InputTypeComposer;
  }
});
Object.defineProperty(exports, "isComposeInputType", {
  enumerable: true,
  get: function get() {
    return _InputTypeComposer.isComposeInputType;
  }
});
Object.defineProperty(exports, "EnumTypeComposer", {
  enumerable: true,
  get: function get() {
    return _EnumTypeComposer.EnumTypeComposer;
  }
});
Object.defineProperty(exports, "ScalarTypeComposer", {
  enumerable: true,
  get: function get() {
    return _ScalarTypeComposer.ScalarTypeComposer;
  }
});
Object.defineProperty(exports, "InterfaceTypeComposer", {
  enumerable: true,
  get: function get() {
    return _InterfaceTypeComposer.InterfaceTypeComposer;
  }
});
Object.defineProperty(exports, "UnionTypeComposer", {
  enumerable: true,
  get: function get() {
    return _UnionTypeComposer.UnionTypeComposer;
  }
});
Object.defineProperty(exports, "Resolver", {
  enumerable: true,
  get: function get() {
    return _Resolver.Resolver;
  }
});
Object.defineProperty(exports, "TypeStorage", {
  enumerable: true,
  get: function get() {
    return _TypeStorage.TypeStorage;
  }
});
Object.defineProperty(exports, "TypeMapper", {
  enumerable: true,
  get: function get() {
    return _TypeMapper.TypeMapper;
  }
});
Object.defineProperty(exports, "GraphQLDate", {
  enumerable: true,
  get: function get() {
    return _type.GraphQLDate;
  }
});
Object.defineProperty(exports, "GraphQLBuffer", {
  enumerable: true,
  get: function get() {
    return _type.GraphQLBuffer;
  }
});
Object.defineProperty(exports, "GraphQLGeneric", {
  enumerable: true,
  get: function get() {
    return _type.GraphQLGeneric;
  }
});
Object.defineProperty(exports, "GraphQLJSON", {
  enumerable: true,
  get: function get() {
    return _type.GraphQLJSON;
  }
});
Object.defineProperty(exports, "getProjectionFromAST", {
  enumerable: true,
  get: function get() {
    return _projection.getProjectionFromAST;
  }
});
Object.defineProperty(exports, "getFlatProjectionFromAST", {
  enumerable: true,
  get: function get() {
    return _projection.getFlatProjectionFromAST;
  }
});
Object.defineProperty(exports, "toInputObjectType", {
  enumerable: true,
  get: function get() {
    return _toInputObjectType.toInputObjectType;
  }
});
Object.defineProperty(exports, "convertInputObjectField", {
  enumerable: true,
  get: function get() {
    return _toInputObjectType.convertInputObjectField;
  }
});
Object.defineProperty(exports, "toDottedObject", {
  enumerable: true,
  get: function get() {
    return _toDottedObject.default;
  }
});
Object.defineProperty(exports, "deepmerge", {
  enumerable: true,
  get: function get() {
    return _deepmerge.default;
  }
});
Object.defineProperty(exports, "filterByDotPaths", {
  enumerable: true,
  get: function get() {
    return _filterByDotPaths.filterByDotPaths;
  }
});
Object.defineProperty(exports, "pluralize", {
  enumerable: true,
  get: function get() {
    return _pluralize.pluralize;
  }
});
exports.graphql = exports.sc = exports.schemaComposer = void 0;

var graphql = _interopRequireWildcard(require("./graphql"));

exports.graphql = graphql;

var _SchemaComposer = require("./SchemaComposer");

var _ObjectTypeComposer = require("./ObjectTypeComposer");

var _InputTypeComposer = require("./InputTypeComposer");

var _EnumTypeComposer = require("./EnumTypeComposer");

var _ScalarTypeComposer = require("./ScalarTypeComposer");

var _InterfaceTypeComposer = require("./InterfaceTypeComposer");

var _UnionTypeComposer = require("./UnionTypeComposer");

var _Resolver = require("./Resolver");

var _TypeStorage = require("./TypeStorage");

var _TypeMapper = require("./TypeMapper");

var _type = require("./type");

var _projection = require("./utils/projection");

var _toInputObjectType = require("./utils/toInputObjectType");

var _misc = require("./utils/misc");

Object.keys(_misc).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _misc[key];
    }
  });
});

var _is = require("./utils/is");

Object.keys(_is).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _is[key];
    }
  });
});

var _graphqlVersion = require("./utils/graphqlVersion");

Object.keys(_graphqlVersion).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _graphqlVersion[key];
    }
  });
});

var _toDottedObject = _interopRequireDefault(require("./utils/toDottedObject"));

var _deepmerge = _interopRequireDefault(require("./utils/deepmerge"));

var _filterByDotPaths = require("./utils/filterByDotPaths");

var _pluralize = require("./utils/pluralize");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const schemaComposer = new _SchemaComposer.SchemaComposer();
exports.schemaComposer = schemaComposer;
const sc = schemaComposer;
exports.sc = sc;